Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 90271)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 90272)
@@ -380,6 +380,9 @@
 void UIMediumSizeAndPathGroupBox::setMediumPath(const QString &strMediumPath)
 {
-    if (m_pLocationEditor)
-        m_pLocationEditor->setText(strMediumPath);
+    if (!m_pLocationEditor)
+        return;
+    m_pLocationEditor->blockSignals(true);
+    m_pLocationEditor->setText(strMediumPath);
+    m_pLocationEditor->blockSignals(false);
 }
 
@@ -398,5 +401,5 @@
                                   arg(stripFormatExtension(fileInfo.fileName(), formatExtensions)).
                                   arg(strDefaultExtension));
-            m_pLocationEditor->setText(newFileInfo.absoluteFilePath());
+            setMediumPath(newFileInfo.absoluteFilePath());
         }
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90271)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90272)
@@ -126,6 +126,9 @@
         UIWizardNewVMNameOSTypePage::guessOSTypeFromName(m_pNameAndSystemEditor, strNewName);
     UIWizardNewVMNameOSTypePage::composeMachineFilePath(m_pNameAndSystemEditor, qobject_cast<UIWizardNewVM*>(wizard()));
-    if (!m_userModifiedParameters.contains("MediumPath"))
+    if (!m_userModifiedParameters.contains("MediumPath") && m_pSizeAndLocationGroup)
+    {
         updateVirtualMediumPathFromMachinePathName();
+        newVMWizardPropertySet(MediumPath, m_pSizeAndLocationGroup->mediumPath());
+    }
     if (!m_userModifiedParameters.contains("HostnameDomainName"))
         updateHostnameDomainNameFromMachineName();
@@ -137,6 +140,9 @@
     Q_UNUSED(strNewPath);
     UIWizardNewVMNameOSTypePage::composeMachineFilePath(m_pNameAndSystemEditor, qobject_cast<UIWizardNewVM*>(wizard()));
-    if (!m_userModifiedParameters.contains("MediumPath"))
+    if (!m_userModifiedParameters.contains("MediumPath") && m_pSizeAndLocationGroup)
+    {
         updateVirtualMediumPathFromMachinePathName();
+        newVMWizardPropertySet(MediumPath, m_pSizeAndLocationGroup->mediumPath());
+    }
 }
 
@@ -375,4 +381,6 @@
 void UIWizardNewVMPageExpert::initializePage()
 {
+    /* We need not to check existence of parameter within m_userModifiedParameters since initializePage() runs
+        once the page loads before user has a chance to modify parameters explicitly: */
     UIWizardNewVM *pWizard = qobject_cast<UIWizardNewVM*>(wizard());
     AssertReturnVoid(pWizard);
@@ -390,6 +398,7 @@
         if (m_pFormatButtonGroup)
             newVMWizardPropertySet(MediumFormat, m_pFormatButtonGroup->mediumFormat());
-        if (!m_userModifiedParameters.contains("MediumPath"))
-            updateVirtualMediumPathFromMachinePathName();
+        /* First set value for medium path in widget the wizard: */
+        updateVirtualMediumPathFromMachinePathName();
+        newVMWizardPropertySet(MediumPath, m_pSizeAndLocationGroup->mediumPath());
     }
 
@@ -398,14 +407,11 @@
     {
         m_pUserNamePasswordGroupBox->blockSignals(true);
-        if (!m_userModifiedParameters.contains("UserName"))
-            m_pUserNamePasswordGroupBox->setUserName(pWizard->userName());
-        if (!m_userModifiedParameters.contains("Password"))
-            m_pUserNamePasswordGroupBox->setPassword(pWizard->password());
+        m_pUserNamePasswordGroupBox->setUserName(pWizard->userName());
+        m_pUserNamePasswordGroupBox->setPassword(pWizard->password());
         m_pUserNamePasswordGroupBox->blockSignals(false);
     }
-    if (!m_userModifiedParameters.contains("HostnameDomainName"))
-        updateHostnameDomainNameFromMachineName();
-
-    if (m_pGAInstallationISOContainer && !m_userModifiedParameters.contains("InstallGuestAdditions"))
+    updateHostnameDomainNameFromMachineName();
+
+    if (m_pGAInstallationISOContainer)
     {
         m_pGAInstallationISOContainer->blockSignals(true);