Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp	(revision 90275)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp	(revision 90276)
@@ -234,6 +234,5 @@
 void UIWizardNewVMDiskPageBasic::sltSelectedDiskSourceChanged()
 {
-    if (!m_pDiskSourceButtonGroup)
-        return;
+    AssertReturnVoid(m_pDiskSelector && m_pDiskSourceButtonGroup);
 
     if (m_pDiskSourceButtonGroup->checkedButton() == m_pDiskEmpty)
@@ -242,5 +241,5 @@
     {
         m_enmSelectedDiskSource = SelectedDiskSource_Existing;
-        setVirtualDiskFromDiskCombo();
+        newVMWizardPropertySet(VirtualDisk, m_pDiskSelector->id());
     }
     else
@@ -255,5 +254,6 @@
 void UIWizardNewVMDiskPageBasic::sltMediaComboBoxIndexChanged()
 {
-    setVirtualDiskFromDiskCombo();
+    AssertReturnVoid(m_pDiskSelector);
+    newVMWizardPropertySet(VirtualDisk, m_pDiskSelector->id());
     emit completeChanged();
 }
@@ -512,12 +512,4 @@
     if (m_pFixedCheckBox)
         m_pFixedCheckBox->setEnabled(fEnable);
-}
-
-void UIWizardNewVMDiskPageBasic::setVirtualDiskFromDiskCombo()
-{
-    AssertReturnVoid(m_pDiskSelector);
-    UIWizardNewVM *pWizard = qobject_cast<UIWizardNewVM*>(wizard());
-    AssertReturnVoid(pWizard);
-    pWizard->setVirtualDisk(m_pDiskSelector->id());
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h	(revision 90275)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h	(revision 90276)
@@ -99,5 +99,4 @@
     void cleanupPage();
     void setEnableNewDiskWidgets(bool fEnable);
-    void setVirtualDiskFromDiskCombo();
     QWidget *createDiskWidgets();
     QWidget *createMediumVariantWidgets(bool fWithLabels);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90275)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90276)
@@ -683,6 +683,7 @@
 void UIWizardNewVMPageExpert::sltMediaComboBoxIndexChanged()
 {
+    AssertReturnVoid(m_pDiskSelector);
     /* Make sure to set m_virtualDisk: */
-    setVirtualDiskFromDiskCombo();
+    newVMWizardPropertySet(VirtualDisk, m_pDiskSelector->id());
     emit completeChanged();
 }
@@ -690,6 +691,6 @@
 void UIWizardNewVMPageExpert::sltSelectedDiskSourceChanged()
 {
-    if (!m_pDiskSourceButtonGroup)
-        return;
+    AssertReturnVoid(m_pDiskSelector && m_pDiskSourceButtonGroup);
+
     m_userModifiedParameters << "SelectedDiskSource";
     if (m_pDiskSourceButtonGroup->checkedButton() == m_pDiskEmpty)
@@ -698,5 +699,5 @@
     {
         m_enmSelectedDiskSource = SelectedDiskSource_Existing;
-        setVirtualDiskFromDiskCombo();
+        newVMWizardPropertySet(VirtualDisk, m_pDiskSelector->id());
     }
     else
@@ -820,13 +821,4 @@
         m_pDiskVariantGroupBox->setEnabled(fEnable);
 }
-
-void UIWizardNewVMPageExpert::setVirtualDiskFromDiskCombo()
-{
-    // AssertReturnVoid(m_pDiskSelector);
-    // UIWizardNewVM *pWizard = wizardImp();
-    // AssertReturnVoid(pWizard);
-    // pWizard->setVirtualDisk(m_pDiskSelector->id());
-}
-
 
 QWidget *UIWizardNewVMPageExpert::createNameOSTypeWidgets()
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h	(revision 90275)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h	(revision 90276)
@@ -139,5 +139,4 @@
     void updateHostnameDomainNameFromMachineName();
     void setEnableNewDiskWidgets(bool fEnable);
-    void setVirtualDiskFromDiskCombo();
     void setSkipCheckBoxEnable();
     bool isUnattendedEnabled() const;